# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import Union
from typing_extensions import Literal, Required, TypeAlias, TypedDict

from .artifact_schema_generation_param import ArtifactSchemaGenerationParam
from .generation_test_case_schema_param import GenerationTestCaseSchemaParam

__all__ = ["AutogeneratedDraftTestCaseCreateParams", "TestCaseData"]


class AutogeneratedDraftTestCaseCreateParams(TypedDict, total=False):
    account_id: Required[str]
    """The ID of the account that owns the given entity."""

    approved: Required[bool]
    """Boolean to track whether or not the draft test case is approved"""

    test_case_data: Required[TestCaseData]
    """The data for the test case in a format matching the provided schema_type"""

    schema_type: Literal["GENERATION"]

    topic_str: str


TestCaseData: TypeAlias = Union[ArtifactSchemaGenerationParam, GenerationTestCaseSchemaParam]
