# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import Dict, List, Union, Optional
from typing_extensions import Literal, Annotated, TypeAlias

from .._utils import PropertyInfo
from .._models import BaseModel
from .shared.chunk_extra_info_schema import ChunkExtraInfoSchema
from .shared.string_extra_info_schema import StringExtraInfoSchema
from .evaluation_datasets.flexible_chunk import FlexibleChunk
from .evaluation_datasets.flexible_message import FlexibleMessage

__all__ = [
    "ResultSchemaFlexible",
    "GenerationOutputUnionMember1GenerationOutputUnionMember1Item",
    "GenerationOutputUnionMember1GenerationOutputUnionMember1ItemFile",
    "GenerationExtraInfo",
]


class GenerationOutputUnionMember1GenerationOutputUnionMember1ItemFile(BaseModel):
    file_type: Literal["image"]

    uri: str


GenerationOutputUnionMember1GenerationOutputUnionMember1Item: TypeAlias = Union[
    str,
    float,
    List[FlexibleChunk],
    List[FlexibleMessage],
    List[object],
    GenerationOutputUnionMember1GenerationOutputUnionMember1ItemFile,
    object,
]

GenerationExtraInfo: TypeAlias = Annotated[
    Union[ChunkExtraInfoSchema, StringExtraInfoSchema], PropertyInfo(discriminator="schema_type")
]


class ResultSchemaFlexible(BaseModel):
    generation_output: Union[str, Dict[str, GenerationOutputUnionMember1GenerationOutputUnionMember1Item]]

    generation_extra_info: Optional[GenerationExtraInfo] = None
